// Code generated by ent, DO NOT EDIT.

package ent

import (
	"fmt"
	"strings"
	"time"

	"entgo.io/ent/dialect/sql"
	"github.com/google/uuid"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/item"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/user"
)

// Item is the model entity for the Item schema.
type Item struct {
	config `json:"-"`
	// ID of the ent.
	ID uuid.UUID `json:"id,omitempty"`
	// Name holds the value of the "name" field.
	Name string `json:"name,omitempty"`
	// Amount holds the value of the "amount" field.
	Amount float64 `json:"amount,omitempty"`
	// OriginalAmount holds the value of the "original_amount" field.
	OriginalAmount float64 `json:"original_amount,omitempty"`
	// UserID holds the value of the "user_id" field.
	UserID uuid.UUID `json:"user_id,omitempty"`
	// RefID holds the value of the "ref_id" field.
	RefID string `json:"ref_id,omitempty"`
	// BuyURL holds the value of the "buy_url" field.
	BuyURL string `json:"buy_url,omitempty"`
	// Thumbnail holds the value of the "thumbnail" field.
	Thumbnail string `json:"thumbnail,omitempty"`
	// Sku holds the value of the "sku" field.
	Sku string `json:"sku,omitempty"`
	// Currency holds the value of the "currency" field.
	Currency string `json:"currency,omitempty"`
	// NativeAmount holds the value of the "native_amount" field.
	NativeAmount float64 `json:"native_amount,omitempty"`
	// Condition holds the value of the "condition" field.
	Condition string `json:"condition,omitempty"`
	// Stock holds the value of the "stock" field.
	Stock int `json:"stock,omitempty"`
	// CreatedAt holds the value of the "created_at" field.
	CreatedAt time.Time `json:"created_at,omitempty"`
	// UpdatedAt holds the value of the "updated_at" field.
	UpdatedAt time.Time `json:"updated_at,omitempty"`
	// Edges holds the relations/edges for other nodes in the graph.
	// The values are being populated by the ItemQuery when eager-loading is set.
	Edges ItemEdges `json:"edges"`
}

// ItemEdges holds the relations/edges for other nodes in the graph.
type ItemEdges struct {
	// User holds the value of the user edge.
	User *User `json:"user,omitempty"`
	// Meta holds the value of the meta edge.
	Meta []*ItemMeta `json:"meta,omitempty"`
	// loadedTypes holds the information for reporting if a
	// type was loaded (or requested) in eager-loading or not.
	loadedTypes [2]bool
}

// UserOrErr returns the User value or an error if the edge
// was not loaded in eager-loading, or loaded but was not found.
func (e ItemEdges) UserOrErr() (*User, error) {
	if e.loadedTypes[0] {
		if e.User == nil {
			// The edge user was loaded in eager-loading,
			// but was not found.
			return nil, &NotFoundError{label: user.Label}
		}
		return e.User, nil
	}
	return nil, &NotLoadedError{edge: "user"}
}

// MetaOrErr returns the Meta value or an error if the edge
// was not loaded in eager-loading.
func (e ItemEdges) MetaOrErr() ([]*ItemMeta, error) {
	if e.loadedTypes[1] {
		return e.Meta, nil
	}
	return nil, &NotLoadedError{edge: "meta"}
}

// scanValues returns the types for scanning values from sql.Rows.
func (*Item) scanValues(columns []string) ([]interface{}, error) {
	values := make([]interface{}, len(columns))
	for i := range columns {
		switch columns[i] {
		case item.FieldAmount, item.FieldOriginalAmount, item.FieldNativeAmount:
			values[i] = new(sql.NullFloat64)
		case item.FieldStock:
			values[i] = new(sql.NullInt64)
		case item.FieldName, item.FieldRefID, item.FieldBuyURL, item.FieldThumbnail, item.FieldSku, item.FieldCurrency, item.FieldCondition:
			values[i] = new(sql.NullString)
		case item.FieldCreatedAt, item.FieldUpdatedAt:
			values[i] = new(sql.NullTime)
		case item.FieldID, item.FieldUserID:
			values[i] = new(uuid.UUID)
		default:
			return nil, fmt.Errorf("unexpected column %q for type Item", columns[i])
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the Item fields.
func (i *Item) assignValues(columns []string, values []interface{}) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for j := range columns {
		switch columns[j] {
		case item.FieldID:
			if value, ok := values[j].(*uuid.UUID); !ok {
				return fmt.Errorf("unexpected type %T for field id", values[j])
			} else if value != nil {
				i.ID = *value
			}
		case item.FieldName:
			if value, ok := values[j].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field name", values[j])
			} else if value.Valid {
				i.Name = value.String
			}
		case item.FieldAmount:
			if value, ok := values[j].(*sql.NullFloat64); !ok {
				return fmt.Errorf("unexpected type %T for field amount", values[j])
			} else if value.Valid {
				i.Amount = value.Float64
			}
		case item.FieldOriginalAmount:
			if value, ok := values[j].(*sql.NullFloat64); !ok {
				return fmt.Errorf("unexpected type %T for field original_amount", values[j])
			} else if value.Valid {
				i.OriginalAmount = value.Float64
			}
		case item.FieldUserID:
			if value, ok := values[j].(*uuid.UUID); !ok {
				return fmt.Errorf("unexpected type %T for field user_id", values[j])
			} else if value != nil {
				i.UserID = *value
			}
		case item.FieldRefID:
			if value, ok := values[j].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field ref_id", values[j])
			} else if value.Valid {
				i.RefID = value.String
			}
		case item.FieldBuyURL:
			if value, ok := values[j].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field buy_url", values[j])
			} else if value.Valid {
				i.BuyURL = value.String
			}
		case item.FieldThumbnail:
			if value, ok := values[j].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field thumbnail", values[j])
			} else if value.Valid {
				i.Thumbnail = value.String
			}
		case item.FieldSku:
			if value, ok := values[j].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field sku", values[j])
			} else if value.Valid {
				i.Sku = value.String
			}
		case item.FieldCurrency:
			if value, ok := values[j].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field currency", values[j])
			} else if value.Valid {
				i.Currency = value.String
			}
		case item.FieldNativeAmount:
			if value, ok := values[j].(*sql.NullFloat64); !ok {
				return fmt.Errorf("unexpected type %T for field native_amount", values[j])
			} else if value.Valid {
				i.NativeAmount = value.Float64
			}
		case item.FieldCondition:
			if value, ok := values[j].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field condition", values[j])
			} else if value.Valid {
				i.Condition = value.String
			}
		case item.FieldStock:
			if value, ok := values[j].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field stock", values[j])
			} else if value.Valid {
				i.Stock = int(value.Int64)
			}
		case item.FieldCreatedAt:
			if value, ok := values[j].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field created_at", values[j])
			} else if value.Valid {
				i.CreatedAt = value.Time
			}
		case item.FieldUpdatedAt:
			if value, ok := values[j].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field updated_at", values[j])
			} else if value.Valid {
				i.UpdatedAt = value.Time
			}
		}
	}
	return nil
}

// QueryUser queries the "user" edge of the Item entity.
func (i *Item) QueryUser() *UserQuery {
	return (&ItemClient{config: i.config}).QueryUser(i)
}

// QueryMeta queries the "meta" edge of the Item entity.
func (i *Item) QueryMeta() *ItemMetaQuery {
	return (&ItemClient{config: i.config}).QueryMeta(i)
}

// Update returns a builder for updating this Item.
// Note that you need to call Item.Unwrap() before calling this method if this Item
// was returned from a transaction, and the transaction was committed or rolled back.
func (i *Item) Update() *ItemUpdateOne {
	return (&ItemClient{config: i.config}).UpdateOne(i)
}

// Unwrap unwraps the Item entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (i *Item) Unwrap() *Item {
	_tx, ok := i.config.driver.(*txDriver)
	if !ok {
		panic("ent: Item is not a transactional entity")
	}
	i.config.driver = _tx.drv
	return i
}

// String implements the fmt.Stringer.
func (i *Item) String() string {
	var builder strings.Builder
	builder.WriteString("Item(")
	builder.WriteString(fmt.Sprintf("id=%v, ", i.ID))
	builder.WriteString("name=")
	builder.WriteString(i.Name)
	builder.WriteString(", ")
	builder.WriteString("amount=")
	builder.WriteString(fmt.Sprintf("%v", i.Amount))
	builder.WriteString(", ")
	builder.WriteString("original_amount=")
	builder.WriteString(fmt.Sprintf("%v", i.OriginalAmount))
	builder.WriteString(", ")
	builder.WriteString("user_id=")
	builder.WriteString(fmt.Sprintf("%v", i.UserID))
	builder.WriteString(", ")
	builder.WriteString("ref_id=")
	builder.WriteString(i.RefID)
	builder.WriteString(", ")
	builder.WriteString("buy_url=")
	builder.WriteString(i.BuyURL)
	builder.WriteString(", ")
	builder.WriteString("thumbnail=")
	builder.WriteString(i.Thumbnail)
	builder.WriteString(", ")
	builder.WriteString("sku=")
	builder.WriteString(i.Sku)
	builder.WriteString(", ")
	builder.WriteString("currency=")
	builder.WriteString(i.Currency)
	builder.WriteString(", ")
	builder.WriteString("native_amount=")
	builder.WriteString(fmt.Sprintf("%v", i.NativeAmount))
	builder.WriteString(", ")
	builder.WriteString("condition=")
	builder.WriteString(i.Condition)
	builder.WriteString(", ")
	builder.WriteString("stock=")
	builder.WriteString(fmt.Sprintf("%v", i.Stock))
	builder.WriteString(", ")
	builder.WriteString("created_at=")
	builder.WriteString(i.CreatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("updated_at=")
	builder.WriteString(i.UpdatedAt.Format(time.ANSIC))
	builder.WriteByte(')')
	return builder.String()
}

// Items is a parsable slice of Item.
type Items []*Item

func (i Items) config(cfg config) {
	for _i := range i {
		i[_i].config = cfg
	}
}
